//+------------------------------------------------------------------+
//|                                  MFT HA Standalone (nrp).mq4     |
//|                                                                  |
//| 2011-12-05 Added new extern options (dynel14)                                                                 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "public domain"
#property link      "http://www.forexfactory.com/showthread.php?t=325018"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 3
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Lime
#property indicator_color4 Red

extern int    Period1 = 1440;
extern int    Period2 = 240;
extern double PeriodTextBuffer = 0.5;

extern int   MaxBars       = 450;
extern color BarColorUp    = Lime;
extern color BarColorDown  = Red;
extern color TextColor     = Lavender;

extern int ArrowHigh       = 10;
extern int ArrowLow        = 2;
extern int ArrowWidth       = 1;

extern color ArrowColorUp     = Aqua;
extern color ArrowColorDown   = Magenta;

extern int FastEma    = 22;
extern int SlowEma    = 264;
extern int SignalSMMA = 8;

extern bool    AlertOn     = true;
extern string  AlertSound  = "Alert.wav";
extern bool    AlertArrow  = true;
extern string  ArrowSound  = "alert2.wav";
extern bool    AlertbyMail = false;
bool AlertSent = false;

extern int BeginTradingHour = 0;
extern int EndTradingHour   = 23;
bool TradingHours;

datetime PrevTime;

int BarWidth = 0;

double buf1_up[];
double buf1_down[];
double buf2_up[];
double buf2_down[];

double PrevHigh2, PrevHigh3, PrevLow2, PrevLow3;
double High2, High3, Low2, Low3;
double PrevHaOpen2, PrevHaOpen3, PrevHaClose2, PrevHaClose3;
double HaOpen2, HaOpen3, HaClose2, HaClose3;
int i2, i3, i4;

string shortname;
string MailBody;

int ArrSize = 110;
int UniqueNum = 2282;

double point;
int LastBars0 = 0;

int dif;
double gp;
string txt, name;
static datetime TimeOpen;

//---------------------------------------------------------
int init()
{
   TimeOpen = Time[0];
   Comment(" ");

   shortname = "FIFO Alert (" + Period1 + "," + Period2 + ")";

   PrevTime = 0;

   SetIndexStyle(0, DRAW_ARROW, 0, BarWidth, BarColorUp);
   SetIndexArrow(0, ArrSize);
   SetIndexBuffer(0, buf1_up);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW, 0, BarWidth, BarColorDown);
   SetIndexArrow(1, ArrSize);
   SetIndexBuffer(1, buf1_down);
   SetIndexEmptyValue(1, 0.0);
   SetIndexStyle(2, DRAW_ARROW, 0, BarWidth, BarColorUp);
   SetIndexArrow(2, ArrSize);
   SetIndexBuffer(2, buf2_up);
   SetIndexEmptyValue(2, 0.0);
   SetIndexStyle(3, DRAW_ARROW, 0, BarWidth, BarColorDown);
   SetIndexArrow(3, ArrSize);
   SetIndexBuffer(3, buf2_down);
   SetIndexEmptyValue(3, 0.0);
/*

   SetIndexLabel(2, NULL);
   SetIndexLabel(3, NULL);
   SetIndexLabel(4, NULL);
   SetIndexLabel(5, NULL);
   SetIndexLabel(6, NULL);
   SetIndexLabel(7, NULL);
*/
   IndicatorDigits(0);

   IndicatorShortName(shortname);

   point = Point;
   if (Digits % 2 == 1) 
      point *= 10;
   
   return(0);
}
   
//---------------------------------------------------------
int deinit()
{
   DeleteOwnArrows();

   return(0);
}

//---------------------------------------------------------
int start()
{
   TradingHours = false;
   if(TimeHour(Time[0]) >= BeginTradingHour && TimeHour(Time[0]) < EndTradingHour)
      TradingHours = true;

   if (Bars - 100 < MaxBars || MaxBars == 0) 
      MaxBars = Bars - 101;
   if (IndicatorCounted() < 0) 
      return(-1);

   int i, start;

   if ((PrevTime == 0) || (Time[Bars - IndicatorCounted()] < PrevTime))
   {
      DeleteOwnArrows();
      start = MaxBars + 100;
      i = start; 
      i2 = iBarShift(NULL, Period1, Time[i]); 
      i3 = iBarShift(NULL, Period2, Time[i]);
      PrevHaOpen2 = iOpen(NULL, Period1, i2); 
      PrevHaOpen3 = iOpen(NULL, Period2, i3);
      PrevHigh2 = High[i]; 
      PrevHigh3 = High[i];
      PrevLow2 = Low[i]; 
      PrevLow3 = Low[i];
      i--;
      
      for(; i >= MaxBars; i--)
      {
         // MTF HA calculations
         // Period0 - can calculate straight away
         
         // Period1 - carefully written code to avoid looking into the future (repainting)
         if (i2 > 0)
            if (Time[i] >= iTime(NULL, Period1, i2 - 1))
            {
               PrevHaOpen2 = (PrevHaOpen2 + PrevHaClose2) * 0.5;
               i2--;
               PrevHigh2 = High[i];
               PrevLow2 = Low[i];
            }
         if (High[i] > PrevHigh2) 
            PrevHigh2 = High[i];
         if (Low[i] < PrevLow2) 
            PrevLow2 = Low[i];
         PrevHaClose2 = (iOpen(NULL, Period1, i2) + PrevHigh2 + PrevLow2 + Close[i]) * 0.25;
         
         // Period2 - carefully written code to avoid looking into the future (repainting)
         if (i3 > 0)
            if (Time[i] >= iTime(NULL, Period2, i3 - 1))
            {
               PrevHaOpen3 = (PrevHaOpen3 + PrevHaClose3) * 0.5;
               i3--;
               PrevHigh3 = High[i];
               PrevLow3 = Low[i];
            }
         if (High[i] > PrevHigh3) 
            PrevHigh3 = High[i];
         if (Low[i] < PrevLow3) 
            PrevLow3 = Low[i];
         PrevHaClose3 = (iOpen(NULL, Period2, i3) + PrevHigh3 + PrevLow3 + Close[i]) * 0.25;
         // MTF HA finished    
      }// end for(; i >= start - MaxBars; i--)
      PrevTime = Time[MaxBars];
      // now PrevHaOpen1,2,3, PrevHaClose1,2,3, PrevHigh2,3 and PrevLow2,3 are calculated on bar with open time PrevTime
   }// end if ((PrevTime == 0) || (Time[Bars - IndicatorCounted()] < PrevTime))
  
   dif = Time[1] - Time[2];
   for(i = ObjectsTotal() - 1; i > -1; i--)
   {
      if (StringFind(ObjectName(i), "FF_" + UniqueNum + "_") >= 0)  ObjectDelete(ObjectName(i));
   }

   // period 1
   txt = tf2txt(Period1); gp = 1.5 + PeriodTextBuffer;
   name = "FF_" + UniqueNum + "_2_" + txt;
   ObjectCreate(name, OBJ_TEXT, WindowFind(shortname), iTime(NULL, 0, 0) + dif * 3, gp);
   ObjectSetText(name, txt, 8, "Arial", TextColor);

   // period 2
   txt = tf2txt(Period2); gp = 2.5 + PeriodTextBuffer;
   name = "FF_" + UniqueNum + "_3_" + txt;
   ObjectCreate(name, OBJ_TEXT, WindowFind(shortname), iTime(NULL, 0, 0) + dif * 3, gp);
   ObjectSetText(name, txt, 8, "Arial", TextColor);
   // calculations (quite complicated becase we want to avoid higher-timeframe bar repainting issue)
   i = iBarShift(NULL, 0, PrevTime); 
   i2 = iBarShift(NULL, Period1, Time[i]); 
   i3 = iBarShift(NULL, Period2, Time[i]);
   High2 = PrevHigh2; 
   High3 = PrevHigh3; 
   Low2 = PrevLow2; 
   Low3 = PrevLow3; 
   HaOpen2 = PrevHaOpen2; 
   HaOpen3 = PrevHaOpen3; 
   HaClose2 = PrevHaClose2; 
   HaClose3 = PrevHaClose3;
   i--;
   for(; i >= 0; i--)
   {
      PrevTime = Time[i + 1]; 
      PrevHigh2 = High2; 
      PrevHigh3 = High3; 
      PrevLow2 = Low2; 
      PrevLow3 = Low3;
      PrevHaOpen2 = HaOpen2; 
      PrevHaOpen3 = HaOpen3; 
      PrevHaClose2 = HaClose2; 
      PrevHaClose3 = HaClose3; 
      // again, now PrevHaOpen1,2,3 and PrevHaClose1,2,3, PrevHigh2,3 and PrevLow2,3 are calculated on bar with open time PrevTime

      // MTF HA calculations
      // Period0 - can calculate straight away
  
      // Period1 - carefully written code to avoid looking into the future (repainting)
      if (i2 > 0)
         if (Time[i] >= iTime(NULL, Period1, i2 - 1))
         {
            HaOpen2 = (HaOpen2 + HaClose2) * 0.5;
            i2--;
            High2 = High[i];
            Low2 = Low[i];
         }
      if (High[i] > High2) High2 = High[i];
      if (Low[i] < Low2) Low2 = Low[i];
      HaClose2 = (iOpen(NULL, Period1, i2) + High2 + Low2 + Close[i]) * 0.25;    
      buf1_up[i] = 1 * (HaOpen2 < HaClose2); buf1_down[i] = 1 * (HaOpen2 > HaClose2);
    
      // Period2 - carefully written code to avoid looking into the future (repainting)
      if (i3 > 0)
         if (Time[i] >= iTime(NULL, Period2, i3 - 1))
         {
            HaOpen3 = (HaOpen3 + HaClose3) * 0.5;
            i3--;
            High3 = High[i];
            Low3 = Low[i];
         }
      if (High[i] > High3) High3 = High[i];
      if (Low[i] < Low3) Low3 = Low[i];
      HaClose3 = (iOpen(NULL, Period2, i3) + High3 + Low3 + Close[i]) * 0.25;
      buf2_up[i] = 2 * (HaOpen3 < HaClose3); buf2_down[i] = 2 * (HaOpen3 > HaClose3);
      // MTF HA finished
      // finally!    
      if (i == 0) 
         SendAlert(i);
      else
         mDrawArrows(i);
    
      DeleteOldTempArrows();
   }
  
   return(0); 
} 

//---------------------------------------------------------
string tf2txt(int tf)
{
   if (tf == PERIOD_M1)
      return("M1");
   if (tf == PERIOD_M5)    
      return("M5");
   if (tf == PERIOD_M15)   
      return("M15");
   if (tf == PERIOD_H1)    
      return("H1");
   if (tf == PERIOD_H4)    
      return("H4");
   if (tf == PERIOD_D1)    
      return("D1");  
   if (tf == PERIOD_M30)    
      return("M30"); 
   
   return("??");
}
  
//---------------------------------------------------------
void mDrawArrows(int j)
{
   double indMacdMain0 = iMACD(NULL,0,FastEma, SlowEma, SignalSMMA,PRICE_CLOSE,0,j);
   double indMacdSignal0 = iMACD(NULL,0,FastEma, SlowEma, SignalSMMA,PRICE_CLOSE,1,j);
   double indMacdMain1 = iMACD(NULL,0,FastEma, SlowEma, SignalSMMA,PRICE_CLOSE,0,j+1);
   double indMacdSignal1 = iMACD(NULL,0,FastEma, SlowEma, SignalSMMA,PRICE_CLOSE,1,j+1);

   if (buf1_down[j] == 1 && buf2_down[j] == 2 && indMacdMain0 < indMacdSignal0 && 
      (buf1_up[j+1] == 1 || buf2_up[j+1] == 2 || indMacdMain1 >= indMacdSignal1)) 
   {
      string objNamesell = "mSell" + Time[j];
      ObjectCreate(objNamesell, OBJ_ARROW, 0, 0, 0, 0, 0);    //Draw Down arrow
      ObjectSet(objNamesell, OBJPROP_PRICE1, High[j] + (ArrowHigh) * point);
      ObjectSet(objNamesell, OBJPROP_TIME1, Time[j]);
      ObjectSet(objNamesell, OBJPROP_COLOR, ArrowColorDown);
      ObjectSet(objNamesell, OBJPROP_WIDTH, ArrowWidth);
      ObjectSet(objNamesell, OBJPROP_ARROWCODE, 234);
      WindowRedraw();
      if (j == 1 && AlertArrow && TradingHours) 
         PlaySound(ArrowSound);
   }
   else 
   if (buf1_up[j] == 1 && buf2_up[j] == 2 && indMacdMain0 >= indMacdSignal0 &&
      (buf1_down[j+1] == 1 || buf2_down[j+1] == 2 || indMacdMain1 < indMacdSignal1))
   {
      string objNameBuy = "mBuy" + Time[j];
      ObjectCreate(objNameBuy, OBJ_ARROW, 0, 0, 0, 0, 0);    //Draw Up arrow
      ObjectSet(objNameBuy, OBJPROP_PRICE1, Low[j] - (ArrowLow) * point);
      ObjectSet(objNameBuy, OBJPROP_TIME1, Time[j]);
      ObjectSet(objNameBuy, OBJPROP_COLOR, ArrowColorUp);
      ObjectSet(objNameBuy, OBJPROP_WIDTH, ArrowWidth);
      ObjectSet(objNameBuy, OBJPROP_ARROWCODE, 233);
      WindowRedraw();
      if (j == 1 && AlertArrow && TradingHours)
         PlaySound(ArrowSound);
   }
   return;
}

//---------------------------------------------------------
void SendAlert(int j)
{
   if(AlertOn && TradingHours)
   {
      if (TimeOpen < Time[0]) // no alert sent yet this bar
      {
         double indMacdMain0 = iMACD(NULL,0,FastEma, SlowEma, SignalSMMA,PRICE_CLOSE,0,0);
         double indMacdSignal0 = iMACD(NULL,0,FastEma, SlowEma, SignalSMMA,PRICE_CLOSE,1,0);
         double indMacdMain1 = iMACD(NULL,0,FastEma, SlowEma, SignalSMMA,PRICE_CLOSE,0,1);
         double indMacdSignal1 = iMACD(NULL,0,FastEma, SlowEma, SignalSMMA,PRICE_CLOSE,1,1);
   
         if (buf1_down[0] == 1 && buf2_down[0] == 2 && indMacdMain0 < indMacdSignal0 && 
            (buf1_up[1] == 1 || buf2_up[1] == 2 || indMacdMain1 >= indMacdSignal1))
         {
            string objNamesell = "mSellTemp" + Time[j] + " P" + Period1;
            ObjectCreate(objNamesell, OBJ_ARROW, 0, 0, 0, 0, 0);    //Draw Down arrow
            ObjectSet(objNamesell, OBJPROP_PRICE1, High[j] + (ArrowHigh) * point);
            ObjectSet(objNamesell, OBJPROP_TIME1, Time[j]);
            ObjectSet(objNamesell, OBJPROP_COLOR, Red);
            ObjectSet(objNamesell, OBJPROP_WIDTH, 0);
            ObjectSet(objNamesell, OBJPROP_ARROWCODE, 234);
            WindowRedraw();

            Alert("Possible Sell on ",Symbol()," ",Period(),"M");
            if(AlertSound!="")
               PlaySound(AlertSound);

            if(AlertbyMail)
             {
              MailBody = "FIFO ALERT. Possible Sell on " + Symbol();
              SendMail("FIFO ALERT",MailBody);
             }
         
            TimeOpen = Time[0];
         }

         if (buf1_up[0] == 1 && buf2_up[0] == 2 && indMacdMain0 >= indMacdSignal0 &&
            (buf1_down[1] == 1 || buf2_down[1] == 2 || indMacdMain1 < indMacdSignal1))
         {
            string objNameBuy = "mBuyTemp" + Time[j] + " P" + Period1;
            ObjectCreate(objNameBuy, OBJ_ARROW, 0, 0, 0, 0, 0);    //Draw Up arrow
            ObjectSet(objNameBuy, OBJPROP_PRICE1, Low[j] - (ArrowLow) * point);
            ObjectSet(objNameBuy, OBJPROP_TIME1, Time[j]);
            ObjectSet(objNameBuy, OBJPROP_COLOR, Lime);
            ObjectSet(objNameBuy, OBJPROP_WIDTH, 0);
            ObjectSet(objNameBuy, OBJPROP_ARROWCODE, 233);
            WindowRedraw();

            Alert("Possible Buy on ",Symbol()," ",Period(),"M");
            if(AlertSound!="")
               PlaySound(AlertSound);

            if(AlertbyMail)
             {
              MailBody = "FIFO ALERT. Possible Buy on " + Symbol();
              SendMail("FIFO ALERT",MailBody);
             }
            TimeOpen = Time[0];
         }
      }
   }

  return;
}

//---------------------------------------------------------
void DeleteOwnArrows(){

  int    obj_total=ObjectsTotal();
  string ObjName;
  
  for(int i = ObjectsTotal() - 1; i > -1; i--)
    {
         
     ObjName=ObjectName(i); 
     if (StringFind(ObjName,"mBuy",0) == 0) ObjectDelete(ObjName);
     if (StringFind(ObjName,"mSell",0) == 0) ObjectDelete(ObjName);
    }
}

//---------------------------------------------------------
void DeleteOldTempArrows(){

  int    obj_total=ObjectsTotal();
  string ObjName;
  datetime ObjTime;
  
  for(int i = ObjectsTotal() - 1; i > -1; i--)
    {
         
     ObjName = ObjectName(i); 
     ObjTime = ObjectGet(ObjName,OBJPROP_TIME1);
     if (StringFind(ObjName,"Temp",0) > 0 && ObjTime < Time[0]) ObjectDelete(ObjName);
    }
}